-- 社团答题信息栏
checkRequire("Lua_LeftInfoBaseWindow");
Lua_FactionBonfireTaskWindow = class("Lua_FactionBonfireTaskWindow", Lua_LeftInfoBaseWindow);
function Lua_FactionBonfireTaskWindow:ctor()
   	self:superCall("ctor");

	self.windowName = "Lua_FactionBonfireTaskWindow";
	self.skinName = "FactionBonfireTaskWindow_skin";
	self.isModel = false;
	self.showClose = false;
end

function Lua_FactionBonfireTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.timer = 0;

	self.titleLab.text = DataCenter.xianshiData:getDataById(DataCenter.factionBonfireData.activityId).name;

	self.infoBtn:addClickFuntion(self, self.onInfoBtn);
	self.rankBtn:addClickFuntion(self, self.openRankWindow);

	self:upDataRankInfo();

	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
	self:addLuaEvent("UPDATA_BONFIRE_PANEL", self, self.updataFromServer);
	self:addLuaEvent("SETGANGRANKINFO", self, self.upDataRankInfo);
	DataCenter.factionBonfireData:sFactionBonfireInfo();
end

function Lua_FactionBonfireTaskWindow:setShowState(val)
	self:superCall("setShowState", val);

	if val then
		self.closeBtn:setLocation(253.5, 197, 0);
		self.closeIcon:setLocation(252, 201, 0);
	else
		self.closeBtn:setLocation(253.5 + self.closeBtn.width + 13, 197, 0);
		self.closeIcon:setLocation(252 - 1.5 + self.closeBtn.width + 13, 201, 0);
	end
end

function Lua_FactionBonfireTaskWindow:onInfoBtn()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(121064));
end

function Lua_FactionBonfireTaskWindow:openRankWindow()
	Lua_WindowUtil.openWin("Lua_GangAnswarRankWindow", WinParam.ACTION_OPEN, nil);
end

function Lua_FactionBonfireTaskWindow:upDataRankInfo()
	local gangTotal = DataCenter.factionData.gangTotal;
	local gangRank = DataCenter.factionData.gangRank
	self.IntegralTxt.text = gangTotal == nil and 0 or gangTotal;
	self.rankTxt.text = gangRank == nil and 0 or gangRank;
end

function Lua_FactionBonfireTaskWindow:onMenuOutClick(o)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121635), type = 1, subFun = self.onOutClick});
end

function Lua_FactionBonfireTaskWindow:onOutClick()
	sendMsg(10400902);
	self:hide();
end

function Lua_FactionBonfireTaskWindow:updataFromServer()
	self.pepleNumTxt.text = LanUtil.formateStr(LanUtil.getValue(121053), tostring(DataCenter.factionBonfireData.players));
	self.additionTxt.text = LanUtil.formateStr(LanUtil.getValue(110308), tostring(DataCenter.factionBonfireData.rewardPer / 100));
	self.getExpTxt.text = tostring(Lua_CommonUtil.getNumberTrans(DataCenter.factionBonfireData.addExp));
	self.boxTxt.text = DataCenter.factionBonfireData.stage .."/".. DataCenter.factionBonfireData.chestTimes;
	
	self.timer = DataCenter.factionBonfireData.leftTime;
	Lua_CommonUtil.addTimer("Lua_FactionBonfireTaskWindow", 1, self, self.countDown);
end

function Lua_FactionBonfireTaskWindow:countDown()
	self.timeTxt.text = TimeTransform.getInstance():transSeconds1(self.timer, true);
	self.timer = self.timer - 1;
	if self.timer < 0 then
		Lua_CommonUtil.removeTimer(self, self.countDown);
	end
end

function Lua_FactionBonfireTaskWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.countDown);
	self:superCall("dispose");
end